2007-06-04 09:09:03 +04:00
#!/bin/sh
#################################
# interface event script for ctdb
# this adds/removes IPs from your
# public interface
2007-09-14 08:14:03 +04:00
. $CTDB_BASE/functions
2009-11-19 07:00:17 +03:00
loadconfig
2007-06-04 09:09:03 +04:00
2007-09-04 03:50:07 +04:00
[ -z "$CTDB_PUBLIC_ADDRESSES" ] && {
2007-09-14 08:14:03 +04:00
CTDB_PUBLIC_ADDRESSES=$CTDB_BASE/public_addresses
2007-06-11 02:42:51 +04:00
}
2007-06-04 09:09:03 +04:00
2007-09-04 03:50:07 +04:00
[ ! -f "$CTDB_PUBLIC_ADDRESSES" ] && {
2008-01-16 14:06:44 +03:00
echo "No public addresses file found. Nothing to do for 10.interfaces"
2007-09-04 03:50:07 +04:00
exit 0
}
2007-06-04 09:09:03 +04:00
2009-12-14 13:59:45 +03:00
monitor_interfaces()
{
local INTERFACES=`cat $CTDB_PUBLIC_ADDRESSES |
sed -e "s/^[^\t ]*[\t ]*//" -e "s/,/ /g" -e "s/[\t ]*$//"`
[ "$CTDB_PUBLIC_INTERFACE" ] && INTERFACES="$CTDB_PUBLIC_INTERFACE $INTERFACES"
[ "$CTDB_NATGW_PUBLIC_IFACE" ] && INTERFACES="$CTDB_NATGW_PUBLIC_IFACE $INTERFACES"
2009-12-22 17:25:30 +03:00
local IFACES=`ctdb ifaces -Y | grep -v '^:Name:LinkStatus:References:'`
local I
2009-12-14 13:59:45 +03:00
local IFACE
2009-12-22 17:25:30 +03:00
for I in $IFACES; do
IFACE=`echo -n "$I" | cut -d ':' -f2`
INTERFACES="$IFACE $INTERFACES"
done
2009-12-14 13:59:45 +03:00
INTERFACES=`for IFACE in $INTERFACES ; do echo $IFACE ; done | sort | uniq`
local fail=0
2009-12-22 17:25:30 +03:00
local force_fail=0
local ok=0
2009-12-14 13:59:45 +03:00
for IFACE in $INTERFACES ; do
2009-12-22 17:25:30 +03:00
local OLDLINK=`echo -n "$IFACES" | grep "^:$IFACE:" | cut -d ':' -f3 | xargs`
test -z "$OLDLINK" && {
force_fail=1
}
2009-12-14 13:59:45 +03:00
# These interfaces are sometimes bond devices
# When we use VLANs for bond interfaces, there will only
# be an entry in /proc for the underlying real interface
local REALIFACE=`echo $IFACE |sed -e 's/\..*$//'`
[ -f /proc/net/bonding/$REALIFACE ] && {
grep -q 'Currently Active Slave: None' /proc/net/bonding/$REALIFACE && {
echo "ERROR: No active slaves for bond device $REALIFACE"
fail=1
2009-12-22 17:25:30 +03:00
test -n "$OLDLINK" && {
ctdb setifacelink $IFACE down
}
2009-12-14 13:59:45 +03:00
continue;
}
grep -q '^MII Status: up' /proc/net/bonding/$REALIFACE || {
echo "ERROR: public network interface $REALIFACE is down"
fail=1
2009-12-22 17:25:30 +03:00
test -n "$OLDLINK" && {
ctdb setifacelink $IFACE down
}
2009-12-14 13:59:45 +03:00
continue;
}
2009-12-22 17:25:30 +03:00
test -n "$OLDLINK" && {
ok=1 # we only set ok for interfaces known to ctdbd
ctdb setifacelink $IFACE up
}
2009-12-14 13:59:45 +03:00
return 0;
}
case $IFACE in
ib*)
# we dont know how to test ib links
;;
*)
[ -z "$IFACE" ] || {
/usr/sbin/ethtool $IFACE | grep -q 'Link detected: yes' || {
# On some systems, this is not successful when a
# cable is plugged but the interface has not been
# brought up previously. Bring the interface up and
# try again...
/sbin/ip link set $IFACE up
/usr/sbin/ethtool $IFACE | grep -q 'Link detected: yes' || {
echo "ERROR: No link on the public network interface $IFACE"
fail=1
2009-12-22 17:25:30 +03:00
test -n "$OLDLINK" && {
ctdb setifacelink $IFACE down
}
2009-12-14 13:59:45 +03:00
continue
}
}
2009-12-22 17:25:30 +03:00
test -n "$OLDLINK" && {
ok=1 # we only set ok for interfaces known to ctdbd
ctdb setifacelink $IFACE up
}
2009-12-14 13:59:45 +03:00
}
;;
esac
done
2009-12-22 17:25:30 +03:00
test x"$fail" = x"0" && {
return 0;
}
test x"$force_fail" != x"0" && {
return 1;
}
test x"$ok" = x"1" && {
return 2;
}
return 1;
2009-12-14 13:59:45 +03:00
}
2009-12-01 09:43:47 +03:00
case "$1" in
2007-06-04 09:09:03 +04:00
#############################
# called when ctdbd starts up
2010-01-19 12:07:14 +03:00
init)
2007-09-08 02:09:02 +04:00
# make sure that we only respond to ARP messages from the NIC where
# a particular ip address is associated.
2007-09-12 07:23:36 +04:00
[ -f /proc/sys/net/ipv4/conf/all/arp_filter ] && {
echo 1 > /proc/sys/net/ipv4/conf/all/arp_filter
}
2007-09-14 04:37:10 +04:00
cat "$CTDB_PUBLIC_ADDRESSES" | cut -d/ -f1 | while read _IP; do
2007-09-14 05:56:40 +04:00
_IP_HELD=`/sbin/ip addr show | grep "inet $_IP/"`
2007-09-14 04:37:10 +04:00
[ -z "$_IP_HELD" ] || {
_IFACE=`echo $_IP_HELD | sed -e "s/.*\s//"`
_NM=`echo $_IP_HELD | sed -e "s/.*$_IP\///" -e "s/\s.*//"`
2008-01-16 14:06:44 +03:00
echo "Removing public address $_IP/$_NM from device $_IFACE"
2007-09-14 05:56:40 +04:00
/sbin/ip addr del $_IP/$_NM dev $_IFACE
2007-09-14 04:37:10 +04:00
}
done
2007-06-04 09:09:03 +04:00
;;
################################################
# called when ctdbd wants to claim an IP address
takeip)
2009-12-01 09:43:47 +03:00
if [ $# != 4 ]; then
2008-01-16 14:06:44 +03:00
echo "must supply interface, IP and maskbits"
2007-06-04 09:09:03 +04:00
exit 1
fi
2009-12-01 09:43:47 +03:00
iface=$2
ip=$3
maskbits=$4
2007-06-04 09:09:03 +04:00
2009-12-18 13:08:22 +03:00
add_ip_to_iface $iface $ip $maskbits || {
exit 1;
2007-06-04 09:09:03 +04:00
}
2009-12-18 13:08:22 +03:00
2007-09-13 04:24:48 +04:00
# cope with the script being killed while we have the interface blocked
2008-02-07 07:36:26 +03:00
iptables -D INPUT -i $iface -d $ip -j DROP 2> /dev/null
2007-06-04 09:09:03 +04:00
# flush our route cache
echo 1 > /proc/sys/net/ipv4/route/flush
;;
##################################################
# called when ctdbd wants to release an IP address
releaseip)
2009-12-01 09:43:47 +03:00
if [ $# != 4 ]; then
2008-01-16 14:06:44 +03:00
echo "must supply interface, IP and maskbits"
2007-06-04 09:09:03 +04:00
exit 1
fi
2007-09-13 04:24:48 +04:00
# releasing an IP is a bit more complex than it seems. Once the IP
# is released, any open tcp connections to that IP on this host will end
# up being stuck. Some of them (such as NFS connections) will be unkillable
# so we need to use the killtcp ctdb function to kill them off. We also
# need to make sure that no new connections get established while we are
# doing this! So what we do is this:
# 1) firewall this IP, so no new external packets arrive for it
# 2) use netstat -tn to find existing connections, and kill them
# 3) remove the IP from the interface
# 4) remove the firewall rule
2009-12-01 09:43:47 +03:00
iface=$2
ip=$3
maskbits=$4
2007-09-13 04:24:48 +04:00
failed=0
# we do an extra delete to cope with the script being killed
2008-02-07 07:36:26 +03:00
iptables -D INPUT -i $iface -d $ip -j DROP 2> /dev/null
iptables -I INPUT -i $iface -d $ip -j DROP
2007-09-13 04:24:48 +04:00
kill_tcp_connections $ip
2007-09-14 05:56:40 +04:00
2009-12-18 13:08:22 +03:00
delete_ip_from_iface $iface $ip $maskbits || {
iptables -D INPUT -i $iface -d $ip -j DROP 2> /dev/null
exit 1;
2007-09-14 05:56:40 +04:00
}
2009-12-18 13:08:22 +03:00
2009-09-01 21:12:27 +04:00
iptables -D INPUT -i $iface -d $ip -j DROP 2> /dev/null
2007-06-04 09:09:03 +04:00
# flush our route cache
echo 1 > /proc/sys/net/ipv4/route/flush
;;
###########################################
# called when ctdbd has finished a recovery
recovered)
;;
####################################
# called when ctdbd is shutting down
shutdown)
;;
2007-06-06 06:08:42 +04:00
monitor)
2009-12-14 13:59:45 +03:00
monitor_interfaces
ret=$?
2009-12-09 03:33:04 +03:00
2009-12-14 13:59:45 +03:00
test x"$ret" != x"0" && {
exit 1;
}
2007-06-06 06:08:42 +04:00
;;
2009-12-01 09:43:47 +03:00
*)
ctdb_standard_event_handler "$@"
2009-11-19 07:00:17 +03:00
;;
2007-06-04 09:09:03 +04:00
esac
exit 0
2007-09-04 03:50:07 +04:00